﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore;
using Microsoft.AspNetCore.Hosting;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Mvc;

namespace App
{
    public class Program
    {
        public static void Main(string[] args)
        {
            new WebHostBuilder()
                .UseKestrel()
                .ConfigureServices(svcs => svcs
                    .AddHttpContextAccessor()
                    .AddSingleton<IFoobar, Foo>()
                    .AddSingleton<IFoobar, Bar>()
                    .AddSingleton<IFoobar, FoobarSelector>()
                    .AddMvc())
                .Configure(app => app
                    .UseDeveloperExceptionPage()
                    .UseMvc())
                .Build()
                .Run();
        }
    }

    public class HomeController: Controller
    {
        private readonly IFoobar _foobar;
        public HomeController(IFoobar foobar) => _foobar = foobar;

        [HttpGet("/")]
        public Task Index(string source)
        {
            HttpContext.SetInvocationSource(source);
            return _foobar.InvokeAsync(HttpContext);
        }
    }
}
